; slave
; Es tracta de controlar un motor amb un potenciometre.
; De 0% a 45% del potenciometre, el motor ha de girar en sentit CW.
; De 55% a 100% del potenciometre, el motor ha de girar en sentit CCW.
; S'utilitza la tarja FADI_40X2 i UNA TARJA FADILEDS.
; CONFIGURACIONS
#picaxe 40x2		' PICAXE-28X2-5V (18F25K22)
setfreq m8
;****************************************************
;*** Configuracio comandament infrarroig          ***
;****************************************************
symbol codi_davant=$0D
symbol codi_enrere=$16
symbol codi_dreta=$10
symbol codi_esquerra=$11
symbol codi_aturar=$15
symbol codi_arc_esquerra=$12
symbol codi_arc_dreta=$13
symbol detector_IR=C.0
;****************************************************
;*** Configuracio sensors  			40X2    ***
;****************************************************
symbol sensor_dreta=3
symbol sensor_esquerra=2
symbol potenciometre=A.0
symbol sensor_1=A.1
symbol sensor_2=A.2
symbol sensor_3=A.3
symbol sensor_5=A.5
symbol sensor_6=A.6
symbol sensor_7=A.7
symbol led_5=C.5
symbol led_3=B.3
symbol led_2=B.2
symbol led_1=B.1
symbol led_0=B.0
symbol led_dreta=B.3
symbol led_esquerra=B.2
symbol n_convertions_adc=4
;****************************************************
;*** Configuracio botons                 40X2     ***
;****************************************************
symbol pujar = pinC.6
symbol baixar = pinC.7
;****************************************************
;*** Configuracio bridge motors          40x2     ***
;****************************************************
symbol Positiu_Mdreta = B.5
symbol Negatiu_Mdreta = B.4
symbol Enable_Mdreta = C.2
symbol Positiu_Mesquerra = B.7
symbol Negatiu_Mesquerra = B.6
symbol Enable_Mesquerra = C.1
high Enable_Mdreta
high Enable_Mesquerra
;****************************************************
;*** Definicio de variables                  ***
;****************************************************
symbol codi_comand=b0	; codi premut del comandament IR
symbol taula_veritat=b1 ; Combinaci? decimal taula veritat de rastrejador
symbol left_dark=b2	; Lectura sensor esquerra llum ambient
symbol left_light=b3	; Lectura sensor esquerra reflexio
symbol left_sensor=b4	; Lectura esquerra
symbol left_sensor_=b5	;
symbol right_dark=b6	; Lectura sensor dreta llum ambient
symbol right_light=b7	; Lectura sensor dreta reflexio
symbol right_sensor=b8; Lectura dreta
symbol right_sensor_=b9	; Lectura dreta
symbol i2cbus=b10		;
symbol shadow=b11		; Per interrupcions
symbol AA=b12		; index bucle de test comandament
symbol BB=b13		; index bucle de test comandament
symbol comande=20
symbol codi=b19
symbol codi_=b20
symbol optoA=b21
symbol optoB=b22
symbol PWMA=b25
symbol PWMB=b26
symbol aleatori=b27
symbol done=b28
symbol done_tim=b29
symbol graf=b30
symbol lim_compte=b31
symbol comptador=b32
symbol lectura=b34

symbol k=b40
symbol adc_acum=w23
;************************************************************
;DEFINICIO DE CONSTANTS
;************************************************************
symbol temps_adc=10
symbol llindar_dreta = 4
symbol llindar_esquerra = 4
;************************************************************
;CONFIGURACIO BUS I2C
;************************************************************
;let i2cbus=$E8
call codificar_portd
hi2csetup i2cslave,i2cbus
pause 1000				; imprescindible no quantificat
;************************************************************
;*** Scratchpad I2C                                       ***
;************************************************************
symbol @i2c_com=20
symbol @i2c_optoA=21
symbol @i2c_opto_left=21
symbol @i2c_optoB=22
symbol @i2c_opto_right=22
symbol @i2c_PWMA=25
symbol @i2c_PWMB=26
symbol @i2c_random=27
symbol @i2c_done=28
symbol @i2c_done_tim=29
symbol @i2c_graf=30
;************************************************************
;*** Codi control cinta                                   ***
;************************************************************
symbol cin_aturar=30		; cinta aturada
symbol cin_davant=31		; cinta marxa davant
symbol cin_enrere=32		; cinta marxa enrere
symbol cin_A_left=40		; cinta marxa davant fins left
symbol cin_A_right=41		; cinta marxa enrere fins righ
symbol cin_A_left_tim=42	; cinta marxa enrere fins righ + tim
symbol cin_A_right_tim=43	; cinta marxa enrere fins righ + tim
symbol cin_reset=49		; cinta marxa enrere fins righ + tim
;************************************************************
;PROGRAMA PRINCIPAL INICIAL
;************************************************************
call aturar					; cinta aturada
call control_pwma:			; ACTICA PWMA
;setintflags %01000000,%01000000	; Activa interrupcions I2C
let done=1
let graf=0
put @i2c_done,done
let done_tim=1
put @i2c_done_tim,done_tim
let lim_compte=30
let comptador=0
let codi=0
let codi_=0
;************************************************************
;PROGRAMA PRINCIPAL REITERATIU
;************************************************************
;setint %00000000,%00000001; activar aquesta l?nia en test comandament
main:;  nomes activar un test. Provar-los individualment.
;call test_motors 	; 40x2 endavant,enrere; dreta, esquerra.
;call test_detectors    ; 40x2 NO DETECTA: enrere, DETECTA: davant.    
;call test_botons       ; 40x2 BAIXAR:endavant esqu  PUJAR: davant dreta
;call test_leds_sensors ; 40x2 ESQUERRA: rapid, DRETA: lent
;call test_encoders	; 40x2 les sortides en leds B.3, B.2, B.1, B.0
;call test_comandament	; 40x2 activar interrupcions.
call pwm_control_pot
goto main
;************************************************************
;SUBRUTINES
;************************************************************
pwm_control_pot:
readadc a.0,lectura
call moviment
; PWM m?xim:499 m?nim motor experimental:199
symbol minim=99
symbol maxim=499
symbol span=w19
;let lectura=230
if lectura<116	then
let w18=maxim-minim
let w19=lectura*w18
let w20=w19/100
let w21=maxim-w20
endif

if lectura>140 then
let w18=maxim-minim
let lectura=255-lectura
let w19=lectura*w18
let w20=w19/100
let w21=maxim-w20
endif

;pwmout pwmdiv16, Enable_Mdreta, 124, w21 ; 1000Hz at 90% @ 8MHz
;pwmout pwmdiv16, Enable_Mesquerra, 124, w21 ; 1000Hz at 90% @ 8MHz
return
moviment:
select case lectura
case <116	
high Positiu_Mdreta,Positiu_Mesquerra
low Negatiu_Mdreta,Negatiu_Mesquerra
pwmout pwmdiv16, Enable_Mdreta, 124, w21 ; 1000Hz at 90% @ 8MHz
pwmout pwmdiv16, Enable_Mesquerra, 124, w21 ; 1000Hz at 90% @ 8MHz
case >141	
high Negatiu_Mdreta,Negatiu_Mesquerra
low Positiu_Mdreta,Positiu_Mesquerra
pwmout pwmdiv16, Enable_Mdreta, 124, w21 ; 1000Hz at 90% @ 8MHz
pwmout pwmdiv16, Enable_Mesquerra, 124, w21 ; 1000Hz at 90% @ 8MHz
else
call aturar_esquerra
call aturar_dreta
low Enable_Mdreta,Enable_Mesquerra
endselect
return

;pwmout pwmdiv16, C.1, 124, 499 ; 1000Hz at 100% @ 8MHz
;pwmout pwmdiv16, C.1, 124, 99 ; 1000Hz at 20% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 149 ; 1000Hz at 30% @ 8MHz

;pwmout pwmdiv16, C.2, 124, 199 ; 1000Hz at 40% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 249 ; 1000Hz at 50% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 299 ; 1000Hz at 60% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 349 ; 1000Hz at 70% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 399 ; 1000Hz at 80% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 449 ; 1000Hz at 90% @ 8MHz
;pwmout pwmdiv16, C.2, 124, 499 ; 1000Hz at 100% @ 8MHz





return





;************************************************************
control_pwma:
pwmout pwmdiv16, Enable_Mdreta, 124, 499 ; 1000Hz at 100% @ 8MHz
pwmout pwmdiv16, Enable_Mesquerra, 124, 499 ; 1000Hz at 100% @ 8MHz
return
;************************************************************
;SECUENCIA D'INTERRUPCIO
;************************************************************
interrupt:							; el sensor ha rebut algo
LET pinsc=%00000000					; deixa el display en blanc
irin [1,lloc_timeout],detector_IR,codi_comand	; llegir el sensor IR
call codi_comandament					; convertir el codi llegit
lloc_timeout:
let AA=0
setint %00000000,%0000001				; reactivar interrupcio
return
;************************************************************
;SUBRUTINES
;************************************************************
test_comandament:
;setint %00000000,%00000001
pause 10
if AA>100 then 				; DESPR?S DE PREMER UN BOTO DEL COMANDAMENT
		 	call restituir	; DURANT 100 VEGADES*10ms= 1SEGON fa el
		 	else inc AA		; mateix moviment
endif
debug codi_comandament
return
restituir:
call aturar
let AA=0
return
codi_comandament:
select case codi_comand
case codi_davant
call davant
case codi_enrere
call enrere
case codi_dreta
call dreta
case codi_esquerra
call esquerra
case codi_aturar
call aturar
case codi_arc_esquerra
call arc_esquerra
case codi_arc_dreta
call arc_dreta
endselect
return
llegir_esquerra:
let k=n_convertions_adc					; defineix el bucle
let adc_acum=0						; esborra acumulador
llegir_esquerra_:
low led_esquerra						; apaga LED
pause temps_adc
readadc sensor_esquerra,left_dark			; llegeix dark
high led_esquerra						; encen LED
pause temps_adc
readadc sensor_esquerra,left_light			; llegeix light
pause temps_adc
low led_esquerra						; apaga LED
if left_light>left_dark then
		let left_sensor=left_light-left_dark
	else
		let left_sensor=0
endif	
let left_sensor_=0			; MSB=0
let adc_acum=adc_acum+left_sensor	; acumula LSB
dec k
if k<>0 then goto llegir_esquerra_
let left_sensor=adc_acum/n_convertions_adc ; comput final
end_llegir_esquerra:
put @i2c_optoA,left_sensor				; Desa valor a scrtchpad I2C
let optoA=left_sensor
return
llegir_dreta:
let k=n_convertions_adc					; defineix el bucle
let adc_acum=0						; esborra acumulador
llegir_dreta_:
low led_dreta						; apaga LED
pause temps_adc
readadc sensor_dreta,right_dark			; llegeix foscor
high led_dreta						; ENCEN LED
pause temps_adc	
readadc sensor_dreta,right_light			; llegeix llum
pause temps_adc
low led_dreta						; apaga LED
if right_light>right_dark then
		; llun superior a foscor
		let right_sensor=right_light-right_dark
	else
		let right_sensor=0
endif
let right_sensor_=0			; MSB=0
let adc_acum=adc_acum+right_sensor	; acumula LSB
dec k
if k<>0 then goto llegir_dreta_
let right_sensor=adc_acum/n_convertions_adc ; comput final
;let @i2c_opto_left=0
let optoB=right_sensor
put @i2c_optoB,right_sensor
;poke right_sensor,optoB

;debug
;pause 100
return
;************************************************************
;TEST DISPOSITIUS
;************************************************************
test_detectors:
;setint %00000000,%00000000
call test_esquerra
call test_dreta
return
test_dreta:
call llegir_dreta
if right_sensor>llindar_dreta then call davant_dreta
if right_sensor=<llindar_dreta then call aturar_dreta
return
test_esquerra:
call llegir_esquerra
if left_sensor>llindar_esquerra then call davant_esquerra
if left_sensor=<llindar_esquerra then call aturar_esquerra
return
test_leds_sensors:
high led_3
pause 200
low led_3
high led_2
pause 200
low led_2
high led_1
pause 200
low led_1
high led_0
pause 200
low led_0
high led_5
pause 200
low led_5
return
test_motors:
if baixar=1 then goto test_motors_
RETURN
test_motors_:
call davant
pause 3000
call enrere
pause 3000
call dreta
pause 3000
call esquerra
pause 1000
call aturar
pause 5000
return
test_botons:
if pujar=1 then call davant_dreta
if pujar=0 then call aturar_dreta
if baixar=1 then call davant_esquerra
if baixar=0 then call aturar_esquerra
if pujar=1 then high led_dreta endif
if pujar=0 then low led_dreta endif
if baixar=1 then high led_esquerra endif
if baixar=0 then low led_esquerra endif
return
return
test_encoders:
;setintflags %00000000,%00000000	; Activa interrupcions I2C
call codificar_portd

if pinC.6=1 then 
		let i2cbus = i2cbus and %11110000
		if i2cbus>=128 then
			let i2cbus=i2cbus-128
			high B.3
				else low B.3
		endif
		if i2cbus>=64 then
			let i2cbus=i2cbus-64
			high B.2
				else low B.2
		endif
		if i2cbus>=32 then
			let i2cbus=i2cbus-32
			high B.1
				else low B.1
		endif
		if i2cbus>=16 then
			let i2cbus=i2cbus-16
			high B.0
				else low B.0
		endif
endif
if pinC.6=0 then 
		let i2cbus = i2cbus and %00001111
		if i2cbus>=8 then
			let i2cbus=i2cbus-8
			high B.3
				else low B.3
		endif
		if i2cbus>=4 then
			let i2cbus=i2cbus-4
			high B.2
				else low B.2
		endif
		if i2cbus>=2 then
			let i2cbus=i2cbus-2
			high B.1
				else low B.1
		endif
			if i2cbus>=1 then
			let i2cbus=i2cbus-1
			high B.0
				else low B.0
		endif
endif
return
codificar_portd:
let BB=0
let dirsd=%00000000; 0 entrada 1 sortida 
		if pind.0=1 then let BB=BB+2 endif
		if pind.1=1 then let BB=BB+1 endif
		if pind.2=1 then let BB=BB+8 endif
		if pind.3=1 then let BB=BB+4 endif
		if pind.4=1 then let BB=BB+32 endif
		if pind.5=1 then let BB=BB+16 endif
		if pind.6=1 then let BB=BB+128 endif
		if pind.7=1 then let BB=BB+64 endif	
LET i2cbus=BB
return
;************************************************************
;SUBRUTINES DE MOVIMENT
;************************************************************
soft_davant:
call davant
pause 100
call aturar_de_davant
return
soft_arc_esquerra:
call esquerra
call arc_esquerra
pause 50
call aturar_de_dreta
return
soft_arc_dreta:
call dreta
call arc_dreta
pause 50
call aturar_de_esquerra
return
davant:
low Enable_Mesquerra,Enable_Mdreta
high Positiu_Mdreta,Positiu_Mesquerra
low Negatiu_Mdreta,Negatiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
enrere:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta,Positiu_Mesquerra
high Negatiu_Mdreta,Negatiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
dreta:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta,Negatiu_Mesquerra
high Negatiu_Mdreta,Positiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
arc_dreta:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta,Negatiu_Mesquerra,Negatiu_Mdreta,Positiu_Mesquerra
high Positiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
esquerra:
low Enable_Mesquerra,Enable_Mdreta
low Negatiu_Mdreta,Positiu_Mesquerra
high Positiu_Mdreta,Negatiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
arc_esquerra:
low Enable_Mesquerra,Enable_Mdreta
low Negatiu_Mdreta,Positiu_Mesquerra,Positiu_Mdreta,Negatiu_Mesquerra
high Positiu_Mdreta
high Enable_Mesquerra,Enable_Mdreta
return
davant_dreta:
low Enable_Mesquerra,Enable_Mdreta
high Positiu_Mdreta
low Negatiu_Mdreta
high Enable_Mesquerra,Enable_Mdreta
return
davant_esquerra:
low Enable_Mesquerra,Enable_Mdreta
high Positiu_Mesquerra
low Negatiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
enrere_dreta:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta
high Negatiu_Mdreta
high Enable_Mesquerra,Enable_Mdreta
return
enrere_esquerra:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mesquerra
high Negatiu_Mesquerra
high Enable_Mesquerra,Enable_Mdreta
return
aturar:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta,Negatiu_Mdreta
high Negatiu_Mesquerra,Positiu_Mesquerra
return
aturar_dreta:
low Enable_Mesquerra,Enable_Mdreta
high Positiu_Mdreta,Negatiu_Mdreta
return
aturar_esquerra:
low Enable_Mesquerra,Enable_Mdreta
high Positiu_Mesquerra,Negatiu_Mesquerra
return
aturar_de_esquerra:
low Enable_Mesquerra,Enable_Mdreta
low Negatiu_Mesquerra
return
aturar_de_dreta:
low Enable_Mesquerra,Enable_Mdreta
low Negatiu_Mdreta
return
aturar_de_davant:
low Enable_Mesquerra,Enable_Mdreta
low Negatiu_Mdreta, Negatiu_Mesquerra
return
aturar_de_enrere:
low Enable_Mesquerra,Enable_Mdreta
low Positiu_Mdreta, Positiu_Mesquerra
return

